Procedure movefiles(source.s,dest.s)
  If source<>dest
    dir=ExamineDirectory(#PB_Any,source,"*.*")
    If dir
      While NextDirectoryEntry(dir)
        a$=DirectoryEntryName(dir)
        Select DirectoryEntryType(dir)
          Case #PB_DirectoryEntry_File
            If FileSize(dest+a$)>=0
              DeleteFile(dest+a$)
            EndIf
            RenameFile(source+a$,dest+a$)
          Case #PB_DirectoryEntry_Directory
            If a$<>"." And a$<>".."
              CreateDirectory(dest+a$)
              movefiles(source+a$+"\",dest+a$+"\")
              DeleteDirectory(source+a$,"*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
            EndIf
        EndSelect
      Wend
      FinishDirectory(dir)
    EndIf
  EndIf
EndProcedure

Procedure modins_copyfiles(source.s,dest.s,add.s,Map installed(),out,forced=#False)
  dir=ExamineDirectory(#PB_Any,source+add,"*.*")
  If dir
    While NextDirectoryEntry(dir)
      entry.s=DirectoryEntryName(dir)
      If DirectoryEntryType(dir)=#PB_DirectoryEntry_File
        If installed(add+entry)=#False Or forced=#True Or FileSize(add+entry)<=0
          CopyFile(source+add+entry,dest+add+entry)
          Debug "copy:"+add+entry
        Else
          Debug "nocopy:"+add+entry
        EndIf
        WriteStringN(out,add+entry)
        installed(add+entry)=2
      ElseIf entry<>"." And entry<>".."
        If FileSize(dest+add+entry)=-1 Or installed(add+entry+"\")
          WriteStringN(out,add+entry+"\"); verzeichnis wurde von einen Mod eingefgt
        EndIf
        CreateDirectory(dest+add+entry)
        installed(add+entry+"\")=2
        modins_copyfiles(source,dest,add+entry+"\",installed(),out) ; unterverzeichnis kopieren
      EndIf
      
    Wend
    FinishDirectory(dir)
  EndIf  
EndProcedure
Procedure DeleteInstalledModsFiles(source.s,Map installed(),limit)
  Debug "install mods"
  ForEach installed()
    If installed()<=limit
      entry.s=MapKey(installed())
      If Right(entry,1)<>"\"
        DeleteFile(source+entry)
        Debug "Delete:"+source+entry
      EndIf
    EndIf
  Next
  ForEach installed()
    If installed()<=limit
      entry.s=MapKey(installed())
      If Right(entry,1)="\"
        If GetMaxDirDate(source+entry)=0
          DeleteDirectory(source+entry,"*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
          Debug "deldir:"+source+entry
        EndIf
      EndIf
    EndIf
  Next
EndProcedure
Procedure removemods(*settings.instances)
  MCDir.s=InstancesDir+*settings\path+"\";.minecraft\"
    
  NewMap installed()
  in=ReadFile(#PB_Any,mcdir+"modinstall.inf")
  If in
    While Not Eof(in)
      installed(ReadString(in))=#True
    Wend
    CloseFile(in)
  EndIf
  DeleteInstalledModsFiles(mcdir+".minecraft\",installed(),1)
  DeleteFile(mcdir+"modinstall.inf")
EndProcedure
Procedure installmod(*settings.instances,forced=#False)
  MCDir.s=InstancesDir+*settings\path+"\";.minecraft\"
    
  NewMap installed()
  in=ReadFile(#PB_Any,mcdir+"modinstall.inf")
  If in
    While Not Eof(in)
      installed(ReadString(in))=#True
    Wend
    CloseFile(in)
  EndIf
  
  
  If ListSize(*settings\mods())=0
    DeleteInstalledModsFiles(mcdir+".minecraft\",installed(),1)
    DeleteFile(mcdir+"modinstall.inf")
  Else
    DeleteDirectory(cachedir+"minecraftjar","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
    DeleteDirectory(cachedir+"root","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
    ok=#True
    ForEach *settings\mods()
      If FileSize(moddir+*settings\mods()+"minecraftjar.7z")
        cmd$="x "+Chr(34)+CharToOem(moddir+*settings\mods()+"minecraftjar.7z")+Chr(34)+" * -o"+Chr(34)+chartooem(cachedir+"minecraftjar\")+Chr(34)+" -aoa -hide"
        ret=SevenZip(WindowID(MainWindow), @cmd$,0,0)
      EndIf
      If FileSize(moddir+*settings\mods()+"root.7z")
        cmd$="x "+Chr(34)+CharToOem(moddir+*settings\mods()+"root.7z")+Chr(34)+" * -o"+Chr(34)+chartooem(cachedir+"root\")+Chr(34)+" -aoa -hide"
        ret=SevenZip(WindowID(MainWindow), @cmd$,0,0)
      EndIf
    Next
    
    
    
    out=CreateFile(#PB_Any,mcdir+"modinstall.inf")
    If out
      modins_copyfiles(cachedir+"root\",mcdir+".minecraft\","",installed(),out,forced)
      CloseFile(out)
      DeleteInstalledModsFiles(mcdir+".minecraft\",installed(),1);alte moddaten lschen, falls vorhanden
    EndIf
    
    If GetMaxDirDate(cachedir+"minecraftjar\")
      cmd$="a "+Chr(34)+chartooem(mcdir.s+".minecraft\bin\minecraft.jar")+Chr(34)+" "+Chr(34)+chartooem(cachedir+"minecraftjar\")+Chr(34)+" -r -mx9 -x!meta-inf"
      ret=SevenZip(WindowID(mainwindow), @cmd$, 0,0)
      If ret
        ok=#False
        addmessage("installmod: Can't patch minecraft.jar")
      EndIf
      If ok
        cmd$="d "+Chr(34)+chartooem(mcdir.s+".minecraft\bin\minecraft.jar")+Chr(34)+" META-INF "
        ret=SevenZip(WindowID(mainwindow), @cmd$, 0,0)
        If ret
          ok=#False
          addmessage("installmod: Can't remove meta-inf from minecraft.jar")
        EndIf
      EndIf
    EndIf
    DeleteDirectory(cachedir+"minecraftjar","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
    DeleteDirectory(cachedir+"root","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
  EndIf
EndProcedure
Procedure CheckMod(checkdir.s,outputdir.s)
  CreateDirectory(outputdir)
  CreateDirectory(outputdir+"root")
  CreateDirectory(outputdir+"root\bin")
  CreateDirectory(outputdir+"root\config")
  CreateDirectory(outputdir+"root\resources")
  CreateDirectory(outputdir+"root\mods")
  CreateDirectory(outputdir+"minecraft.jar")
  CreateDirectory(outputdir+"unused")
  
  done=#False
  
  dir=ExamineDirectory(#PB_Any,checkdir,"*.class")
  If dir
    While NextDirectoryEntry(dir)
      If DirectoryEntryType(dir)=#PB_DirectoryEntry_File
        movefiles(checkdir,outputdir+"minecraft.jar\")
        ;Debug "Injekt all to minecraft.jar"
        done=#True
        Break
      EndIf
    Wend
    FinishDirectory(dir)
  EndIf
  
  If done=#False
    dir=ExamineDirectory(#PB_Any,checkdir,"*.*")
    If dir
      While NextDirectoryEntry(dir)
        Select DirectoryEntryType(dir)
          Case #PB_DirectoryEntry_File
            a$=LCase(DirectoryEntryName(dir))
            If Right(a$,4)=".zip"
              RenameFile(checkdir+a$,outputdir+"root\mods\"+a$)
              ;Debug "copy "+a$+" to .minecraft\mods"
            EndIf
          Case #PB_DirectoryEntry_Directory
            folder$=LCase(DirectoryEntryName(dir))
            If folder$<>"." And folder$<>".."
              If FindString(folder$,"mods")>0
                movefiles(checkdir+folder$+"\",outputdir+"root\mods\")
                ;Debug "Copy in .minecraft\mods\ :"+folder$
                done=#True
                
              ElseIf FindString(folder$,"jar")=0 And FindString(folder$,"minecraft")>0 
                movefiles(checkdir+folder$+"\",outputdir+"root\")
                ;Debug "copy to .minecraft\ :"+folder$
                done=#True
                
              ElseIf FindString(folder$,"jar")>0 And FindString(folder$,"minecraft")>0
                ;Debug "injekt to minecraft.jar :"+folder$
                movefiles(checkdir+folder$+"\",outputdir+"minecraft.jar\")
                done=#True
                
              ElseIf FindString(folder$,"resources")>0
                movefiles(checkdir+folder$+"\",outputdir+"root\resources\")
                ;Debug "copy to .minecraft\resources :"+folder$
                done=#True              
                
              ElseIf FindString(folder$,"bin")>0
                dir2=ExamineDirectory(#PB_Any,checkdir+folder$,"*.class")
                If dir2
                  While NextDirectoryEntry(dir2)
                    If DirectoryEntryType(dir2)=#PB_DirectoryEntry_File
                      ;Debug "Injekt to minecraft.jar :"+folder$
                      movefiles(checkdir+folder$+"\",outputdir+"minecraft.jar\")
                      done=#True
                      Break
                    EndIf
                  Wend
                  FinishDirectory(dir2)
                EndIf
                If done=#False
                  ;Debug "copy to .minecraft\bin:"+folder$
                  movefiles(checkdir+folder$+"\",outputdir+"root\bin\")
                  done=#True
                EndIf
                
              ElseIf FindString(folder$,"config")>0
                ;Debug "copy to .minecraft\config :"+folder$
                movefiles(checkdir+folder$+"\",outputdir+"root\config\")
                done=#True
              Else
                ;Debug "unknown:"+folder$
              EndIf
            EndIf
        EndSelect
      Wend
      FinishDirectory(dir)
      
      If done=#False
        dir=ExamineDirectory(#PB_Any,checkdir,"*.*")
        If dir
          While NextDirectoryEntry(dir)
            If DirectoryEntryType(dir)=#PB_DirectoryEntry_Directory
              a$=DirectoryEntryName(dir)
              If a$<>"." And a$<>".."
                ;Debug "new sub:"+a$
                checkmod(checkdir+a$+"\",outputdir)
              EndIf
            EndIf
          Wend
          FinishDirectory(dir)
        EndIf
      EndIf
      
    EndIf
  EndIf
  movefiles(checkdir,outputdir+"unused\")
EndProcedure
Procedure.s DirBack(a$)
  a=0:c=0
  Repeat
    b=FindString(a$,"\",a+1)
    If b
      c=a
      a=b
    Else
      Break
    EndIf
  ForEver
  ProcedureReturn Left(a$,c)
EndProcedure
Procedure CountChar(A$,b$)
  c=0
  For i=1 To Len(a$)
    If Mid(A$,i,1)=b$
      c+1
    EndIf
  Next
  ProcedureReturn c
EndProcedure

Procedure.s mod_changeDir(explorer2,addinfo2,start2$,add2$)
  a=GetGadgetState(explorer2)
  If a>=0
    a$=GetGadgetItemText(explorer2,a)
    type=GetGadgetItemState(explorer2,a)&(#PB_Explorer_Directory|#PB_Explorer_File)
    If type=#PB_Explorer_Directory
      add2$ +a$+"\"
      SetGadgetText(explorer2,start2$+add2$)
      SetGadgetText(addinfo2,"\"+add2$)
    EndIf
  EndIf
  ProcedureReturn add2$
EndProcedure
Procedure mod_DragFiles(explorer2)
  dest$=GetGadgetText(explorer2)
  a=GetGadgetState(explorer2)
  If a>=0
    If GetGadgetItemState(explorer2,a)&#PB_Explorer_Directory
      dest$+GetGadgetItemText(explorer2,a)+"\"
    EndIf
  EndIf
  filelist.s=EventDropFiles()
  count=CountChar(filelist,Chr(10))+1
  For i=1 To count
    file.s=StringField(filelist,i,Chr(10))
    If FileSize(file)>=0
      CopyFile(file,dest$+GetFilePart(file))
    Else
      CreateDirectory(dest$+GetFilePart(file))
      CopyDirectory(file,dest$+GetFilePart(file),"*.*",#PB_FileSystem_Recursive| #PB_FileSystem_Force  )
    EndIf
  Next
EndProcedure
Procedure mod_DragPrivat(explorer2, List files.s())
  ;ProcedureReturn #False
  dest$=GetGadgetText(explorer2)
  a=GetGadgetState(explorer2)
  If a>=0
    If GetGadgetItemState(explorer2,a)&#PB_Explorer_Directory
      dest$+GetGadgetItemText(explorer2,a)+"\"
    EndIf
  EndIf
  ForEach files()
    file.s=files()
    If file<>Left(dest$,Len(file)) And dest$<>Left(file,Len(dest$))
      If FileSize(file)>=0
        DeleteFile(dest$+GetFilePart(file))
        RenameFile(file,dest$+GetFilePart(file))
      Else
        CreateDirectory(dest$+GetFilePart(file))
        movefiles(file+"\",dest$+GetFilePart(file)+"\")
        DeleteDirectory(file,"*.*",#PB_FileSystem_Recursive| #PB_FileSystem_Force  )
      EndIf
    EndIf
  Next
  ClearList(files())
EndProcedure
Procedure mod_getSelected(explorer1,List files.s())
  ClearList(files())
  c=CountGadgetItems(explorer1)-1
  root$=GetGadgetText(explorer1)
  ;Debug "selected "+Str(c)
  For I=0 To c
    If GetGadgetItemState(explorer1,i)&#PB_Explorer_Selected
      AddElement(files())
      files()=root$+GetGadgetItemText(explorer1,i)
      ;Debug root$+GetGadgetItemText(explorer1,i)
    EndIf
  Next
  ;Debug "----"
EndProcedure

Procedure Mods_Options(*modinfo.mods,mainwin=0)
  ;Debug "---"
  ;Debug mainwin
  If mainwin=0
    mainwin=mainwindow
  EndIf
  ;Debug mainwin
  outdir.s=cachedir+"testmod\"
  DisableWindow(mainwin,#True)
  win_mod=OpenWindow(#PB_Any,0,0,600,425,"Create new mod",#PB_Window_WindowCentered,WindowID(mainwin))
  y=5
  TextGadget(#PB_Any,5,y,100,20,"Version")
  TextGadget(#PB_Any,110,y,600-5-110,20,"Name"):y+20
  gad_ver=ComboBoxGadget(#PB_Any,5,y,100,20)
  gad_name=StringGadget(#PB_Any,110,y,600-5-110,20,*modinfo\name):y+20
  y+10
  
  ;Frame3DGadget(#PB_Any,5-2,y-2,193+4,20+20+9+300,"",#PB_Frame3D_Flat)
  head1=TextGadget(#PB_Any,5,y,193,20,"minecraft.jar",#PB_Text_Center)
  ;Frame3DGadget(#PB_Any,5-2+193+5,y-2,193+4,20+20+9+300,"",#PB_Frame3D_Flat)
  head2=TextGadget(#PB_Any,10+193,y,193,20,"add to .minecraft",#PB_Text_Center)
  ;Frame3DGadget(#PB_Any,5-2+193*2+10,y-2,193+4,20+20+9+300,"",#PB_Frame3D_Flat)
  head3=TextGadget(#PB_Any,15+193*2,y,193,20,"unused",#PB_Text_Center):y+20
  ;y+5
  
  addinfo1=StringGadget(#PB_Any,5,y,193-20,20,"\",#PB_String_ReadOnly)
  addinfo2=StringGadget(#PB_Any,10+193,y,193-20,20,"\",#PB_String_ReadOnly)
  addinfo3=StringGadget(#PB_Any,15+193*2,y,193-20,20,"\",#PB_String_ReadOnly)
  
  back1=ButtonGadget(#PB_Any,5+193-20   ,y,20,20,"...")
  back2=ButtonGadget(#PB_Any,10+193*2-20,y,20,20,"...")
  back3=ButtonGadget(#PB_Any,15+193*3-20,y,20,20,"..."):y+20
  
  start1$=outdir+"minecraft.jar\"
  start2$=outdir+"root\"
  start3$=outdir+"unused\"
  
  add1$=""
  add2$=""
  add3$=""
  
  explorer1=ExplorerListGadget(#PB_Any,5,y,193,300,start1$,#PB_Explorer_NoParentFolder|#PB_Explorer_NoDirectoryChange|#PB_Explorer_MultiSelect)
  explorer2=ExplorerListGadget(#PB_Any,10+193,y,193,300,start2$,#PB_Explorer_NoParentFolder|#PB_Explorer_NoDirectoryChange|#PB_Explorer_MultiSelect)
  explorer3=ExplorerListGadget(#PB_Any,15+193*2,y,193,300,start3$,#PB_Explorer_NoParentFolder|#PB_Explorer_NoDirectoryChange|#PB_Explorer_MultiSelect):y+300
  
  y+5
  
  but_ok=ButtonGadget(#PB_Any,600-200-10,y,100,20,"OK")
  but_cancel=ButtonGadget(#PB_Any,600-100-5,y,100,20,"Cancel"):y+20
  y+5
  ;Debug y
  
  AddGadgetItem(gad_ver,-1,"all")
  SetGadgetState(gad_Ver,0)
  
  ForEach versions()
    ;minecraft - 
    ver$=Mid(versions()\file,13,Len(versions()\file)-12-4)
    AddGadgetItem(gad_ver,-1,ver$)
    If ver$=*modinfo\ver
      SetGadgetState(gad_ver,CountGadgetItems(gad_ver)-1)
      done=#False
    EndIf
  Next
  
  
  
  
  SetGadgetAttribute(explorer1,#PB_Explorer_DisplayMode,#PB_Explorer_List)
  SetGadgetAttribute(explorer2,#PB_Explorer_DisplayMode,#PB_Explorer_List)
  SetGadgetAttribute(explorer3,#PB_Explorer_DisplayMode,#PB_Explorer_List)
  
  SetGadgetColor(head1,#PB_Gadget_BackColor,$ffffff)
  SetGadgetColor(head2,#PB_Gadget_BackColor,$ffffff)
  SetGadgetColor(head3,#PB_Gadget_BackColor,$ffffff)
  SetGadgetColor(head1,#PB_Gadget_FrontColor,0)
  SetGadgetColor(head2,#PB_Gadget_FrontColor,0)
  SetGadgetColor(head3,#PB_Gadget_FrontColor,0)
  
  
  EnableGadgetDrop(explorer2,#PB_Drop_Files, #PB_Drag_Copy)
  EnableGadgetDrop(explorer1,#PB_Drop_Files, #PB_Drag_Copy)
  
  EnableGadgetDrop(explorer1,#PB_Drop_Private,#PB_Drag_Move,1)
  EnableGadgetDrop(explorer2,#PB_Drop_Private,#PB_Drag_Move,1)
  EnableGadgetDrop(explorer3,#PB_Drop_Private,#PB_Drag_Move,1)
  
  NewList selected.s()
  Repeat
    event=WaitWindowEvent()
    Select event
      Case #PB_Event_GadgetDrop
        Select EventDropType()
          Case #PB_Drop_Files
            Select EventGadget()
              Case explorer2
                mod_DragFiles(explorer2)
              Case explorer1
                mod_dragfiles(explorer1)              
            EndSelect
          Case #PB_Drop_Private 
            Select EventGadget()
              Case explorer1
                mod_DragPrivat(explorer1,selected())
              Case explorer2
                mod_DragPrivat(explorer2,selected())
              Case explorer3
                mod_DragPrivat(explorer3,selected())
            EndSelect
        EndSelect
      Case #PB_Event_Gadget
        Select EventType()
          Case #PB_EventType_DragStart
            Select EventGadget()
              Case explorer1
                mod_getSelected(explorer1,selected())
                DragPrivate(1,#PB_Drag_Move)
              Case explorer2
                mod_getSelected(explorer2,selected())
                DragPrivate(1,#PB_Drag_Move)
              Case explorer3
                mod_getSelected(explorer3,selected())
                DragPrivate(1,#PB_Drag_Move)
            EndSelect
          Case #PB_EventType_LeftDoubleClick
            Select EventGadget()
              Case explorer1
                add1$=mod_changeDir(explorer1,addinfo1,start1$,add1$)
              Case explorer2
                add2$=mod_changeDir(explorer2,addinfo2,start2$,add2$)
              Case explorer3
                add3$=mod_changeDir(explorer3,addinfo3,start3$,add3$)
                
            EndSelect
          Case #PB_EventType_LeftClick
            Select EventGadget()
              Case back1
                add1$=DirBack(add1$)
                SetGadgetText(explorer1,start1$+add1$)
                SetGadgetText(addinfo1,"\"+add1$)
              Case back2
                add2$=DirBack(add2$)
                SetGadgetText(explorer2,start2$+add2$)
                SetGadgetText(addinfo2,"\"+add2$)
              Case back3
                add3$=DirBack(add3$)
                SetGadgetText(explorer3,start3$+add3$)
                SetGadgetText(addinfo3,"\"+add3$)
              Case but_ok
                ok=#True
                Break
              Case but_cancel
                ok=#False
                Break
            EndSelect
        EndSelect
        
    EndSelect
  Until event=#PB_Event_CloseWindow
  If ok
    *modinfo\ver=GetGadgetText(gad_ver)
    *modinfo\name=GetGadgetText(gad_name)
  EndIf
  CloseWindow(win_mod)
  DisableWindow(mainwin,#False)
  ProcedureReturn ok
EndProcedure
Procedure savemodini(*modinfo.mods)
  If CreatePreferences(moddir+*modinfo\file+"mod.ini")
    WritePreferenceString("Name",*modinfo\name)
    WritePreferenceString("Version",*modinfo\ver)
    ClosePreferences()
  EndIf
EndProcedure
Procedure Createmod(*modinfo.mods)
  file.s=CreateMCPath("["+*modinfo\ver+"]"+*modinfo\name)
  CreateDirectory(moddir+file)
  file+"\"
  ok=#True
  If GetMaxDirDate(cachedir+"testmod\minecraft.jar\")
    SetCurrentDirectory(cachedir+"testmod\minecraft.jar")
    cmd$="a "+Chr(34)+chartooem(moddir+file+"minecraftjar.7z")+Chr(34)+" * -r -mx9"
    If SevenZip(WindowID(MainWindow), @cmd$, 0,0)
      addmessage("CreateMod:Can't pack minecraftjar.7z")
      ok=#False
    EndIf
  EndIf
  If GetMaxDirDate(cachedir+"testmod\root\")
    SetCurrentDirectory(cachedir+"testmod\root")
    cmd$="a "+Chr(34)+chartooem(moddir+file+"root.7z")+Chr(34)+" * -r -mx9"
    If SevenZip(WindowID(MainWindow), @cmd$, 0,0)
      addmessage("CreateMod:Can't pack root.7z")
      ok=#False
    EndIf
  EndIf
  SetCurrentDirectory(currentdir)
  *modinfo\file=file
  savemodini(*modinfo)
  ProcedureReturn  ok
EndProcedure
Procedure.s ImportMod(file.s,mainwin=0)
  newmod.mods
  ext.s=UCase(GetExtensionPart(file))
  ;Debug ext
  If EXT="ZIP" Or ext="7z"
   
    
    DeleteDirectory(cachedir+"unzipped","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
    DeleteDirectory(cachedir+"testmod","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
    cmd$="x "+Chr(34)+CharToOem(file)+Chr(34)+" * -o"+Chr(34)+chartooem(cachedir+"unzipped\")+Chr(34)+" -aoa -hide"
    ret=SevenZip(WindowID(MainWindow), @cmd$,0,0)
    If ret=#False
      
      checkmod(cachedir+"unzipped\",cachedir+"testmod\")
      
      newmod\name=GetFilePart(file)
      newmod\name=Left(newmod\name,Len(newmod\name)-Len(GetExtensionPart(newmod\name))-1)
      newmod\ver=LatestVersionNr
      If mods_options(newmod,mainwin)
        createmod(newmod)
      EndIf
      
    EndIf
    DeleteDirectory(cachedir+"unzipped","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
    DeleteDirectory(cachedir+"testmod","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
  EndIf  
  ProcedureReturn newmod\file
EndProcedure
Procedure.s NewMod(mainwin=0)
  DeleteDirectory(cachedir+"testmod\","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
  CreateDirectory(cachedir+"testmod")
  CreateDirectory(cachedir+"testmod\root")
  CreateDirectory(cachedir+"testmod\root\bin")
  CreateDirectory(cachedir+"testmod\root\config")
  CreateDirectory(cachedir+"testmod\root\resources")
  CreateDirectory(cachedir+"testmod\root\mods")
  CreateDirectory(cachedir+"testmod\minecraft.jar")
  CreateDirectory(cachedir+"testmod\unused")
  newmod.mods
  newmod\name="new"
  newmod\ver=LatestVersionNr
  If Mods_Options(newmod,mainwin)
    createmod(newmod)
  EndIf
  DeleteDirectory(cachedir+"testmod\","*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
  ProcedureReturn newmod\file
EndProcedure    
    
Procedure ScanMods()
  NewMap sorthelp.s()
    ForEach versions()
    ;minecraft - 
    sorthelp(Mid(versions()\file,13,Len(versions()\file)-12-4))=Str(9999999999-versions()\date)
  Next
  
  sorthelp("all")="0000000000"
  ClearList(mods())
  
  dir=ExamineDirectory(#PB_Any,moddir,"*.*")
  If dir
    While NextDirectoryEntry(dir)
      If DirectoryEntryType(dir)=#PB_DirectoryEntry_Directory
        a$=DirectoryEntryName(dir)
        If a$<>"." And a$<>".."
          AddElement(mods())
          mods()\file=a$+"\"
          Debug moddir+Mods()\file+"mod.ini"
          OpenPreferences(moddir+Mods()\file+"mod.ini")
          mods()\name=ReadPreferenceString("Name","<loaderror>")
          mods()\ver=ReadPreferenceString("Version","<loaderror>")
          ClosePreferences()
          mods()\sort=sorthelp(mods()\ver)+"_"+mods()\name
        EndIf
      EndIf
    Wend
  Else
    addmessage("ScanMods: no mods!")
  EndIf  
  SortStructuredList(Mods(),#PB_Sort_Ascending,OffsetOf(mods\sort),#PB_Sort_String)
EndProcedure
Procedure RebuildMods(gadget_Mods)
  ClearGadgetItems(gadget_Mods)
  ForEach Mods()
    AddGadgetItem(gadget_Mods,-1,Mods()\name+Chr(10)+Mods()\ver)
  Next
EndProcedure

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 122
; FirstLine = 107
; Folding = fAi-
; EnableXP
; UseMainFile = StartMinecraft.pb