Procedure.s GetMineCraftVersion(file.s,*date.long,unpack=#True)
  ver$="":date=0
  If unpack=#True
    class$=cachedir+"Minecraft.class"
    cmd$="e "+Chr(34)+CharToOem(file)+Chr(34)+" net\minecraft\client\Minecraft.class -o"+Chr(34)+chartooem(cachedir)+Chr(34)+" -aoa -hide"
    ret=SevenZip(WindowID(MainWindow), @cmd$, 0,0)
    If ret
      addmessage("GetMineCraftVerion: Can't unpack "+file)
      ProcedureReturn ""
    EndIf
  Else
    class$=file
  EndIf
  
  len=FileSize(class$)
  If len<=0
    addmessage("GetMineCraftVersion: "+class$+" doesn't exist")
    ProcedureReturn ""
  EndIf
  
  *mem=AllocateMemory(len)
  If *mem=0
    addmessage("GetMineCraftVersion: Out of memory")
    If unpack
      DeleteFile(class$)
    EndIf
    ProcedureReturn ""
  EndIf
  
  in=ReadFile(#PB_Any,class$)
  If in=0
    addmessage("GetMineCraftVersion: Can't read "+class$)
    FreeMemory(*mem)
    If unpack
      DeleteFile(class$)
    EndIf
    ProcedureReturn ""
  EndIf
  
  ReadData(in,*mem,len)
  CloseFile(in)
  
  For *I=*mem To *mem+len-20
    If CompareMemory(@"Minecraft Minecraft ",*i,20)=1
      ;Debug file$+" ## "+rename$+" ## "+PeekS(*i+20,PeekB(*I-1)-20)
      ver$=PeekS(*i+20,PeekB(*I-1)-20)
      Break
    EndIf
  Next
  
  FreeMemory(*mem)
  
  *date\l=GetFileDate(class$,#PB_Date_Modified)
  If unpack
    DeleteFile(class$)
  EndIf
  
  
  ProcedureReturn ver$
EndProcedure
Procedure appendversionsini(file.s,minecraftdate,minecraftver.s)
  out=OpenFile(#PB_Any,versionsdir+"ver.ini")
  If out
    FileSeek(out,Lof(out))
    WriteStringN(out,file)
    WriteStringN(out,minecraftver)
    WriteLong(out,minecraftdate)
    CloseFile(out)
  EndIf
EndProcedure  
Procedure ScanVersion()
  NewMap ver.versions()
  ClearList(versions())

  in=OpenFile(#PB_Any,VersionsDir+"ver.ini")
  countdown=9999
  If in
    While Not Eof(in)
      a$=ReadString(in)
      If a$<>""
        ver(a$)\ver=ReadString(in)
        ver(a$)\date=ReadLong(in)
      EndIf
    Wend
    CloseFile(in)    
  EndIf
  
  mustsave=#False

  dir=ExamineDirectory(#PB_Any,VersionsDir,"*.jar")
  If dir
    While NextDirectoryEntry(dir)
      a$=DirectoryEntryName(dir)
      b$=Left(a$,Len(a$)-4)
      AddElement(versions())
      versions()\file=a$
      If ver(a$)\ver
        versions()\ver=ver(a$)\ver
        versions()\date=ver(a$)\date
      Else
        c$=GetMineCraftVersion(versionsdir+a$,@date.l)
        mustsave=#True
        If c$
          versions()\ver=c$
          versions()\date=date
        Else
          versions()\ver="[unknown]"
          versions()\date=GetFileDate(versionsdir+a$,#PB_Date_Modified)
        EndIf
      EndIf
    Wend
    FinishDirectory(dir)
  EndIf
  
  If mustsave
    Debug "save Versions!"
    out=CreateFile(#PB_Any,VersionsDir+"ver.ini")
    If out
      ForEach versions()
        WriteStringN(out,versions()\file)
        WriteStringN(out,versions()\ver)
        WriteLong(out,versions()\date)
      Next
      CloseFile(out)
    EndIf
  EndIf

  SortStructuredList(versions(),#PB_Sort_Descending,OffsetOf(versions\date),#PB_Sort_Long)
  ProcedureReturn #True
EndProcedure
Procedure RebuildVersion(gadget_versions)
  ClearGadgetItems(gadget_versions)
  ForEach versions()
    AddGadgetItem(gadget_versions,-1,versions()\file+Chr(10)+versions()\ver+Chr(10)+FormatDate("%dd.%mm.%yyyy",versions()\date))
  Next
EndProcedure
Procedure downgrade(infile.s,tempdir.s,gadget=#False,dorecu=#False,dounpack=#True)
  ;tempdir.s=versionsdir+"patch\"
  patchfile.s=""
  a$=GetFilePart(infile)

  dir=ExamineDirectory(#PB_Any,patchdir,Left(a$,Len(a$)-4)+"*.patch")
  If dir
    If NextDirectoryEntry(dir)
      patchfile=patchdir+DirectoryEntryName(dir)
    EndIf
    FinishDirectory(dir)
  EndIf
  
  If patchfile=""
    addmessage("Downgrade: no patch file")
    ProcedureReturn #False
  EndIf
  
  ; ok, befinnen wir mit den patchen...
  destfile.s=StringField(GetFilePart(patchfile),2,"#")
  destfile.s=versionsdir+Left(destfile,Len(destfile)-6)+".jar"
  
  If gadget
    SetGadgetText(gadget,GetFilePart(infile)+" to "+GetFilePart(destfile))
  EndIf
  
  ; Zieldatei schon da?
  If FileSize(destfile)>0
    addmessage("Downgrade: File already exist")
    If dorecu
      downgrade(destfile,tempdir,gadget,#True)
    EndIf
    ProcedureReturn #False
  EndIf  
  
  ; entpacken der Ursprungsdatei
  If dounpack
      cmd$="x "+Chr(34)+CharToOem(infile)+Chr(34)+" -hide -aoa -o"+Chr(34)+CharToOem(tempdir)+Chr(34)
      ret=SevenZip(WindowID(MainWindow), @cmd$, 0,0)
    If ret
      addmessage("Downgrade: Can't unpack")
      ProcedureReturn #False
    EndIf
  EndIf
  
  ; Die Filelist zum packen
  out=CreateFile(#PB_Any,tempdir+"__gpi_filelist.txt")
  If out=#False
    addmessage("Downgrade: Can't create filelist")
    ProcedureReturn #False
  EndIf
  
  ; Patchfile ffnen
  in=ReadFile(#PB_Any,patchfile)
  If in=#False
    AddMessage("Downgrade: Can't open patchfile "+patchfile)
    CloseFile(out)
    ProcedureReturn #False
  EndIf
  
  ; Patchdatei abarbeiten
  patchok=#True
  maxdate=0
  minecraftver.s="[unknown]"
  minecraftdate=0
  While Not Eof(in)
    ;Dateiname,crc und gre lesen
    slen=ReadByte(in)&$FF
    file.s=Space(slen)
    ReadData(in,@file,slen)
    crc=ReadLong(in)
    date=ReadLong(in)
    size=ReadLong(in)
    
    ;Debug Str(slen)+" "+file+" "+Str(size)+" "+Str(crc)
    
    ;zur Filelist
    WriteStringN(out,file)
    
    
    ;was liegt denn vor?
    filetype=ReadByte(in)&$ff
    
    Select filetype
      Case 1 ;{ Datei unverndert bernehmen
        ;spezialfall gre=0
        If size=0 And Right(file,1)<>"\" And Right(file,1)<>"/"; And file<>""
          in2=CreateFile(#PB_Any,tempdir+file)
          If in2
            CloseFile(in2)
          Else
            addmessage("Downgrade: Can't create "+tempdir+file)
            patchok=#False
            Break
          EndIf
        EndIf
        ;}
      Case 2 ;{ komplett neu
        CreateTreeFile(tempdir+file)
        out2=CreateFile(#PB_Any,tempdir+file)
        If out2=#False
          addmessage("Downgrade: Can't create "+tempdir+file)
          patchok=#False
          Break
        EndIf
        
        *mem=AllocateMemory(size)
        If *mem=#False
          addmessage("Downgrade: Out of memory (new file)")
          patchok=#False
          CloseFile(out2)
          Break
        EndIf
        
        ReadData(in,*mem,size)
        WriteData(out2,*mem,size)
        CloseFile(out2)
        FreeMemory(*mem)
        ;}
      Case 3 ;{ unterschiedlich
        ;Ursprngliche Datei in Speicher laden
        slen=FileSize(tempdir+file)
        *source=AllocateMemory(slen+size)
        *buf=*source+slen
        If *source=#False
          addmessage("Downgrade: Out of memory (patchfile)")
          patchok=#False
          Break
        EndIf
        
        in2=ReadFile(#PB_Any,tempdir+file)
        If in2=#False
          addmessage("Can't read: "+tempdir+file)
          FreeMemory(*source)
          patchok=#False
          Break
        EndIf
        
        ReadData(in2,*source,slen)
        CloseFile(in2)
        
        out2=CreateFile(#PB_Any,tempdir+file)
        If out2=#False
          addmessage("downgrade: Can't write: "+tempdir)
          FreeMemory(*source)
          patchok=#False
          Break
        EndIf
        
        Repeat
          type=ReadByte(in)&$FF
          Select type
            Case 0
              Break
            Case 101 To 200
              d=type-101 +1
              ReadData(in,*buf,d)
              WriteData(out2,*buf,d)
            Case 1
              d=ReadByte(in)&$FF +1
              ReadData(in,*buf,d)
              WriteData(out2,*buf,d)
            Case 2
              d=ReadWord(in)&$FFFF+1
              ReadData(in,*buf,d)
              WriteData(out2,*buf,d)
            Case 201
              d=ReadLong(in)+1
              ReadData(in,*buf,d)
              WriteData(out2,*buf,d)
            Case 5 To 100
              delta=ReadByte(in)
              d=type
              WriteData(out2,*source+Loc(out2)+delta,d)
            Case 3
              delta=ReadByte(in)
              d=ReadByte(in)&$FF +1+100
              WriteData(out2,*source+Loc(out2)+delta,d)
            Case 4
              delta=ReadByte(in)
              d=ReadWord(in)&$FFFF+1+100
              WriteData(out2,*source+Loc(out2)+delta,d)
            Default
              addmessage("Downgrade: illegal patch-info for "+tempdir+file)
              patchok=#False
              Break
          EndSelect
        ForEver
        CloseFile(out2)
        FreeMemory(*source)
        ;}
      Default
        addmessage("Downgrade: Patchfile corrupt")
        patchok=#False
        Break
    EndSelect
    
    If patchok=#False
      Break
    EndIf
    
    ;so datei berprfen    
    
    If FileSize(tempdir+file)<>size Or CRC32FileFingerprint(tempdir+file)<>crc
      addmessage("Downgrader: wrong file "+file)
      Break
    EndIf
    SetFileDate(tempdir+file,#PB_Date_Modified,date)
    ;Debug file
    If date>maxdate
      maxdate=date
    EndIf
    If file="net\minecraft\client\Minecraft.class"
      ;Debug "MINECRAFT.CLASS"
      minecraftver=GetMineCraftVersion(tempdir+file,@minecraftdate,#False)
    EndIf
  Wend
  
  CloseFile(in)
  CloseFile(out)
  
  If minecraftdate=0
    minecraftdate=maxdate
  EndIf
  appendversionsini(GetFilePart(destfile),minecraftdate,minecraftver)
  
  If patchok=#False
    ProcedureReturn #False
  EndIf
  
  ;so packen wir mal alles zusammen
  SetCurrentDirectory(tempdir)
  
  cmd$="u "+Chr(34)+CharToOem(destfile)+Chr(34)+" -hide -tzip -mx9 @__gpi_filelist.txt"
  ret=SevenZip(WindowID(MainWindow), @cmd$,0,0)
  If ret
    addmessage("Downgrader: Can't create "+destfile)
    patchok=#False     
  EndIf
  
  SetFileDate(destfile,#PB_Date_Modified,maxdate)
  SetCurrentDirectory(CurrentDir)
  
  If patchok=#False
    DeleteFile(destfile)
  ElseIf dorecu 
    downgrade(destfile,tempdir,gadget,#True,#False)
  EndIf
  
  ProcedureReturn patchok
EndProcedure

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 387
; FirstLine = 344
; Folding = --
; EnableXP